set ::design_name te0720_sdsoc





# create hardware platform description
set pfm [sdsoc::create_pfm ${::design_name}.hpfm]
sdsoc::pfm_name $pfm "trenz.biz"  "xd" "${::design_name}" "1.0"
sdsoc::pfm_description $pfm "Trenz Basic SDSoC Platform"

sdsoc::pfm_clock       $pfm clk_out1 clk_wiz_0 0 false proc_sys_reset_50
sdsoc::pfm_clock       $pfm clk_out2 clk_wiz_0 1 true  proc_sys_reset_100
sdsoc::pfm_clock       $pfm clk_out3 clk_wiz_0 2 false proc_sys_reset_120
sdsoc::pfm_clock       $pfm clk_out4 clk_wiz_0 3 false proc_sys_reset_150
sdsoc::pfm_axi_port    $pfm M_AXI_GP0 processing_system7_0 M_AXI_GP
sdsoc::pfm_axi_port    $pfm M_AXI_GP1 processing_system7_0 M_AXI_GP
sdsoc::pfm_axi_port    $pfm S_AXI_ACP processing_system7_0 S_AXI_ACP
sdsoc::pfm_axi_port    $pfm S_AXI_HP0 processing_system7_0 S_AXI_HP
sdsoc::pfm_axi_port    $pfm S_AXI_HP1 processing_system7_0 S_AXI_HP
sdsoc::pfm_axi_port    $pfm S_AXI_HP2 processing_system7_0 S_AXI_HP
sdsoc::pfm_axi_port    $pfm S_AXI_HP3 processing_system7_0 S_AXI_HP
for {set i 0} {$i < 16} {incr i} {
  sdsoc::pfm_irq       $pfm In$i xlconcat_1
}

# generate hardware platform
sdsoc::generate_hw_pfm $pfm

